#!/usr/bin/perl
#-----------------------------------------------------------------------------
# Administrations-Skript des II99-Forums von Thiemo Mttig, thiemo@maettig.com
# Zuletzt ueberarbeitet am 2003-03-07
#-----------------------------------------------------------------------------

# Das Konfigurations-Skript wird hier unbedingt benoetigt! Wenn sich die
# Dateien im gleichen Verzeichnis befinden, wird normalerweise
# "ii99forum_cfg.cgi" geschrieben. Wenn der hohe Sicherheitslevel aktiv ist
# und die Datei ii99forum_admin.cgi in einem gesonderten Unterverzeichnis
# liegt, muss normalerweise "../ii99forum_cfg.cgi" geschrieben werden.
require 'ii99forum_cfg.cgi';

# Das Passwort fuer den niedrigen Sicherheitslevel. Achtung! Diese Methode
# ist sehr unsicher! Das Admin-Skript sollte z.B. durch Entzug der
# Dateirechte weiter geschuetzt werden. Wesentlich sicherer ist es, die
# Datei ii99forum_admin.cgi in einem Unterverzeichnis abzulegen und mittels
# .htaccess und .htpasswd zu schuetzen. In diesem Fall kann die folgende
# Variable leer gelassen werden.
$passwd = '';

#-----------------------------------------------------------------------------

$html_kopf=qq!Content-Type: text/html\n
<html><head><title>II99-Forum-Administration</title>
<meta name="robots" content="noindex,nofollow">
<meta http-equiv="expires" content="0">
<meta http-equiv="pragma" content="no-cache">
</head>
<body bgcolor=white text="#003366" vlink="#333399" link="#6633CC" alink="#9933FF">
<center>
<h1>II99-Forum-Administration</h1>
!;

$html_fuss=qq!
<p><small>Copyright des II99-Forums bei <a href="http://www.maettig.com/">Thiemo M&auml;ttig</a></small>
</center>
</body></html>!;

#-----------------------------------------------------------------------------

&initialisieren;
if ($FORM{'aktion'} eq "statistik") { &statistik; }
elsif ($FORM{'aktion'} eq "check") { &datacheck; }
elsif ($FORM{'aktion'} eq "loeschen") { &eintrag_loeschen; }
elsif ($FORM{'aktion'} eq "edit") { &editieren; }
elsif ($FORM{'aktion'} eq "edit_eintragen") { &edit_eintragen; }
elsif ($FORM{'id'} > 0) { &zeige_eintrag; }
else { &zeige_thread; }
die;

#-----------------------------------------------------------------------------

sub zeige_thread
{
  print $html_kopf;
  print qq!<form method="post" action="$0" name="formular">
  ID: <input type=text size=15 name="id">
  <input type="submit" value="Gehe zu"></form>!;

  print qq!<p>[ <a href="ii99forum.cgi">Zum II99-Forum</a> |
  <a href="$0?aktion=statistik">Statistik</a> |
  <a href="$0?aktion=check">Konsistenz pr&uuml;fen</a> ]</p>!;

  &alles_einlesen;
  if ($anz < 1) { print "<p>Keine Eintr\&auml;ge vorhanden."; print $html_fuss; die; }
  for ($zaehler = 2; $zaehler <= $anz; $zaehler++) { $pointer[$zaehler] = $zaehler - 1; }
  print "<table border=1 cellspacing=0 cellpadding=1>\n";
  print "<tr><th align=left>ID</th><th align=left>Betreff</th><th align=left>Absender</th><th align=right>Datum</th></tr>\n";
  $seite = 1;
  $zaehler = $anz;

  while ($zaehler > 0)
  {
    if ($FORM{'seite'} < 1 || $FORM{'seite'} == $seite)
    {
      $betreff[$zaehler] =~ s/</&lt;/g; $absender[$zaehler] =~ s/</&lt;/g;
      print "<tr><td>$id[$zaehler]</td><td><a href=\"$0?id=$id[$zaehler]\">";
      if ($betreff[$zaehler] eq '')
      {
        print substr($text[$zaehler], 0, $betreffmax);
      }
      else
      {
        print $betreff[$zaehler];
      }
      print "</a></td><td>$absender[$zaehler]</td><td align=right>".&datum($datum[$zaehler])."</td></tr>\n";
    }
    $zaehler = $pointer[$zaehler];
    $zeilencount++;
    if ($zeilencount >= 50)
    {
      if ($seite >= $FORM{'seite'}) { last; }
      $seite++; $zeilencount = 0;
    }
  }

  print "</table>\n<p>[ ";
  if ($FORM{'seite'} > 1)
  {
    print "<a href=\"$0?seite=";
    print $seite - 1 . "\">&lt;&lt;</a>";
  }
  else
  {
    print "&lt;&lt;";
  }
  print " | Seite $seite | ";
  if ($zaehler > 0)
  {
    print "<a href=\"$0?seite=";
    print $seite + 1 . "\">&gt;&gt;</a>";
  }
  else
  {
    print "&gt;&gt;";
  }
  print qq! ]</p>
  <script language="JavaScript" type="text/javascript"><\!--
  document.formular.id.focus();
  //--></script>!;
  print $html_fuss; die;
}

#-----------------------------------------------------------------------------

sub zeige_eintrag
{
  &alles_einlesen;
  if (&suche_arraynum($FORM{'id'}) == -1) { &zeige_thread; }
  print $html_kopf;
  $absender[$arraynum] =~ s/</&lt;/g; $betreff[$arraynum] =~ s/</&lt;/g;
  $text[$arraynum] =~ s/</&lt;/g;     $text[$arraynum] =~ s/%n/<br>/g;

  print "<table border=1 cellspacing=0 cellpadding=3>\n";
  print "<tr><td width=1 align=right>Betreff:</td><td>$betreff[$arraynum]</td></tr>\n";
  print "<tr><td align=right>Absender:</td><td>$absender[$arraynum]";
  if ($email[$arraynum])
  {
    print " &lt;<a href=\"mailto:$email[$arraynum]\">$email[$arraynum]</a>&gt;";
  }
  print "</td></tr>\n<tr><td align=right>Datum:</td><td>" . &datum($datum[$arraynum]) . "</td></tr>\n";

  print '<tr><td align=right>IP:</td><td>';
  print "$ip[$arraynum] (<a href=\"http://www.ripe.net/perl/whois?searchtext=$ip[$arraynum]\" target=\"_blank\">Ripe.net</a>, ";
  $ip[$arraynum] =~ s/(\d*)\.(\d*)\.(\d*)\.(\d*)/ip1=$1&ip2=$2&ip3=$3&ip4=$4/;
  print "<a href=\"http://www.amnesi.com/hostinfo/ipinfo.jhtml?$ip[$arraynum]\" target=\"_blank\">eAmnesia.com</a>)</td></tr>\n";

  if ($re[$arraynum])
  {
    print '<tr><td align=right>Antwort&nbsp;auf:</td><td>';
    print "<a href=\"$0?id=$re[$arraynum]\">$re[$arraynum]</a></td></tr>\n";
  }
  print "<tr><td colspan=2>$text[$arraynum]</td></tr>";
  print "</table>\n";

  print '<p>[ Antworten: ';
  for ($i = $anz; $i > $arraynum; $i--)
  {
    if ($re[$i] == $FORM{'id'})
    {
      if ($res) { print ', '; } else { $res = 1; }
      print "<a href=\"$0?id=$id[$i]\">$id[$i]</a>";
    }
  }
  if (! $res) { print 'keine'; } print " ]<br>\n";
  print "[ <a href=\"$0?id=" . ($FORM{'id'} - 1) . "\">&lt; Vorg&auml;nger</a> | ";
  print "<a href=\"$0?id=" . ($FORM{'id'} + 1) . "\">Nachfolger &gt;</a> ]<br>\n";
  print "[ <a href=\"$0\">Zur&uuml;ck</a> | ";
  print "<a href=\"$0?aktion=edit&id=$FORM{'id'}\">Editieren</a> | ";
  print "<a href=\"$0?aktion=loeschen&id=$FORM{'id'}\">L&ouml;schen</a> ]</p>\n";
  print $html_fuss; die;
}

#-----------------------------------------------------------------------------

sub editieren
{
  print $html_kopf;

  &alles_einlesen;
  &suche_arraynum($FORM{'id'});
  $betreff[$arraynum] =~ s/%a/&/g; $betreff[$arraynum] =~ s/%p/%/g;
  $betreff[$arraynum] =~ s/"/&quot;/g; $absender[$arraynum] =~ s/"/&quot;/g;
  $email[$arraynum] =~ s/"/&quot;/g;
  $text[$arraynum] =~ s/%a/&/g; $text[$arraynum] =~ s/%p/%/g;
  $text[$arraynum] =~ s/%n/\n/g;

  print qq!<p><table cellspacing=0 cellpadding=0 border=0><tr>
  <form method="post" action="$0" name="formular"><td>
  Betreff<br><input type=text size=$form_width name="betreff" value="$betreff[$arraynum]"><br>
  Absender<br><input type=text size=$form_width name="absender" value="$absender[$arraynum]"><br>
  E-Mail<br><input type=text size=$form_width name="email" value="$email[$arraynum]"><br>
  Text<br><textarea rows=15 cols=$form_width wrap=virtual name="text">$text[$arraynum]</textarea><br>
  Antwort auf<br><input type=text size=15 name="re" value="$re[$arraynum]"><br>!;
  #print '<input type=checkbox name="sendmail" value="1"';
  #if ($sendmail[$arraynum] > 0) { print ' checked'; }
  #print "> Antworten als E-Mail schicken<br>\n";
  if ($passwd)
  {
    print "Passwort<br><input type=password size=$form_width name=\"passwd\"><br>\n";
  }
  print qq!<input type=hidden name="aktion" value="edit_eintragen">\n
  <input type=hidden name="id" value="$FORM{'id'}">\n
  <input type="submit" value="Korrektur eintragen">
  </td></form></tr></table>
  <p>[ <a href="$0">Zur&uuml;ck</a> ]</p>
  <script language="JavaScript" type="text/javascript"><\!--
  document.formular.text.focus();//--></script>!;
  print $html_fuss; die;
}

#-----------------------------------------------------------------------------

sub edit_eintragen
{
  if ($FORM{'passwd'} eq $passwd)
  {
    &alles_einlesen;
    &suche_arraynum($FORM{'id'});
    open(DATEI, ">$datafile") || die $!;
    flock(DATEI, 2);
    for ($i = 1; $i <= $anz; $i++)
    {
      if ($i == $arraynum)
      {
        print DATEI "id=$id[$i]&re=$FORM{'re'}&betreff=$FORM{'betreff'}&absender=$FORM{'absender'}";
        if ($FORM{'email'}) { print DATEI "&email=$FORM{'email'}"; }
	print DATEI "&datum=$datum[$i]&text=$FORM{'text'}&ip=$ip[$i]";
        #if ($FORM{'sendmail'} > 0) { print DATEI "&sendmail=1"; }
        print DATEI "\n";
      }
      else
      {
        print DATEI "id=$id[$i]&re=$re[$i]&betreff=$betreff[$i]&absender=$absender[$i]";
        if ($email[$i]) { print DATEI "&email=$email[$i]"; }
	print DATEI "&datum=$datum[$i]&text=$text[$i]&ip=$ip[$i]";
        #if ($sendmail[$i] > 0) { print DATEI "&sendmail=1"; }
        print DATEI "\n";
      }
    }
    close(DATEI);
    &zeige_thread;
  }
  else
  {
    print $html_kopf;
    print "<p>Das Passwort ist falsch.</p>";
    print $html_fuss;
  }
  die;
}

#-----------------------------------------------------------------------------

sub eintrag_loeschen
{
  if ($FORM{'passwd'} eq '' && $FORM{'confirm'} ne 'YES')
  {
    print $html_kopf;
    print qq!<p><table cellspacing=0 cellpadding=0 border=0><tr>
    <form method="post" action="$0" name="formular"><td>
    ID<br><input type=text size=15 name="id" value="$FORM{'id'}"><br>!;
    if ($passwd)
    {
      print "Passwort<br><input type=password size=15 name=\"passwd\"><br>\n";
      print "<script type=\"text/javascript\"><!--\ndocument.formular.passwd.focus();\n//--></script>";
    }
    print qq!Beim Lschen wird keine<br>Sicherheitskopie angelegt\!<br>
    <input type=hidden name="aktion" value="loeschen">
    <input type=hidden name="confirm" value="YES">
    <input type="submit" value="L&ouml;schen"></td></form></tr></table>
    <p>[ <a href="$0">Zur&uuml;ck</a> ]</p>!;
    print $html_fuss;

  }
  elsif ($FORM{'passwd'} eq $passwd)
  {
    &alles_einlesen;
    &suche_arraynum($FORM{'id'});
    open(DATEI, ">$datafile") || die $!;
    flock(DATEI, 2);
    for ($i = 1; $i <= $anz; $i++)
    {
      if ($i == $arraynum) { next; }
      # Eventuelle Antworten im Thread nach oben schieben. Sehr wichtig!
      if ($re[$i] == $FORM{'id'}) { $re[$i] = $re[$arraynum]; }
      print DATEI "id=$id[$i]&re=$re[$i]&betreff=$betreff[$i]&absender=$absender[$i]";
      if ($email[$i]) { print DATEI "&email=$email[$i]"; }
      print DATEI "&datum=$datum[$i]&text=$text[$i]&ip=$ip[$i]";
      #if ($sendmail[$i] > 0) { print DATEI "&sendmail=1"; }
      print DATEI "\n";
    }
    close(DATEI);
    &zeige_thread;

  }
  else
  {
    print $html_kopf, "<p>Das Passwort ist falsch.</p>", $html_fuss;
  }
  die;
}

#-----------------------------------------------------------------------------

sub initialisieren
{
  # Eingabedaten splitten und ins Array $FORM{'...'} schreiben
  if ($ENV{'REQUEST_METHOD'} eq "GET")
  {
    $buffer = $ENV{'QUERY_STRING'};
  }
  else
  {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  } 
  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs)
  {
    ($name, $value) = split(/=/, $pair, 2);
    $value =~ tr/+/ /;

    # Hexadezimal kodierte Zeichen werden aufgeloest
    $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

    $value =~ s/%/%p/g;
    $value =~ s/\r?\n/%n/g;
    $value =~ s/&/%a/g;
    $FORM{$name} = $value;
  }

  # Existenz der Datendatei pruefen und evtl. neu erzeugen
  if (! (-f $datafile))
  {
    open(DATEI, ">$datafile");
    print DATEI '';
    close(DATEI);
  }
  $0 =~ s/.*\///; # Den Dateinamen des Scriptes selbst freistellen
}

#-----------------------------------------------------------------------------

sub alles_einlesen
{
  open(DATEI, "<$datafile") || die $!;
  $anz = 0;
  # Datei zeilenweise einlesen, die Zeile wird in $_ zwischengespeichert
  while (<DATEI>)
  {
    $anz++; chop;
    # Die Zeile an jedem '&' aufsplitten, Speicherung des Teiles in $pair
    foreach $pair (split(/&/))
    {
      # Zerteilen in ein Paar aus Variablenname und Wert
      ($name, $value) = split(/=/, $pair, 2);
      # Uebernahme dieses Wertes in ein normales Array, linear nummeriert
      $$name[$anz] = $value;
    }
  }
  close(DATEI);
}

#-----------------------------------------------------------------------------

sub suche_arraynum
{
  # In $_[0] kommt die zu suchende ID, in $_[1] ein Startwert fuer $arraynum,
  # von dort aus wird rueckwaerts gesucht
  $arraynum = ($_[1] > 0) ? $_[1] : $anz;
  while ($id[$arraynum] != $_[0])
  {
    if (--$arraynum < 1) { return -1; last; }
  }
}

#-----------------------------------------------------------------------------

sub datum
{
  ($sec, $min, $hour, $day, $mon, $year) = localtime($_[0]);
  ++$mon;
  $year += 1900;
  if ($min < 10) { $min = "0$min"; }
  if ($sec < 10) { $sec = "0$sec"; }
  return "$day.$mon.$year,&nbsp;$hour:$min:$sec";
}

#-----------------------------------------------------------------------------

sub statistik
{
  print $html_kopf;
  &alles_einlesen;

  print "<p>Zeitraum der Eintr&auml;ge: ".&datum($datum[1])." bis ".&datum($datum[$anz])."<br>";
  print "Aktuelle Anzahl der Eintr&auml;ge: <b>$anz</b><br>";
  print "Bisher gel&ouml;schte Eintr&auml;ge: <b>";
  print $id[$anz]-$anz; print "</b> (";
  print int(100*($id[$anz]-$anz)/$id[$anz]); print "%)<br>\n";

  for ($i = 1; $i <= $anz; $i++)
  {
    if ($absender[$i] eq '') { $anonym++; }
    if ($email[$i]) { $emails++; }
    if ($betreff[$i] eq '') { $keinbetreff++; }
    if ($text[$i] eq '') { $keintext++; }
    if (length($text[$i]) > $len_max) { $len_max = length($text[$i]); $len_max_id = $id[$i]; }
    $len_durchschnitt += length($text[$i]);
  }
  $len_durchschnitt/=$anz;

  print "Eintr&auml;ge mit E-Mailadresse: <b>$emails</b> (" . int(100*$emails/$anz) . "%)<br>";
  print "Eintr&auml;ge ohne Absender: <b>$anonym</b> (" . int(100*$anonym/$anz) . "%)<br>";
  print "Eintr&auml;ge ohne Betreff: <b>$keinbetreff</b> (" . int(100*$keinbetreff/$anz) . "%)<br>";
  print "Eintr&auml;ge ohne Text: <b>$keintext</b> (" . int(100*$keintext/$anz) . "%)<br>\n";
  print "Lngster Text: <b>$len_max</b> Zeichen (ID <a href=\"$0?id=$len_max_id\">$len_max_id</a>)<br>";
  print "Durchschnittliche Lnge der Texte: <b>" . int($len_durchschnitt) . "</b> Zeichen<br>";

  print "<br><h3>Anzahl der Eintr&auml;ge pro Monat</h3><p>";
  for ($i = 1; $i <= $anz; $i++)
  {
    ($sec, $min, $hour, $day, $mon, $year) = localtime($datum[$i]);
    $s = ($mon+1) . '/' . ($year + 1900);
    if ($s_alt eq '') { $s_alt = $s; }
    $z++;
    if ($s ne $s_alt || $datum[$i+1] eq '')
    {
      print "$s_alt: <b>$z</b> (";
      print int(100*$z/$anz); print "%)<br>";
      $s_alt=$s; $z=0;
    }
  }

  print "<h3>Hufigkeit bei den IPs</h3><p>";
  for ($i = 1; $i <= $anz; $i++) { $statistik{$ip[$i]}++; }
  @keys = sort {$statistik{$b} <=> $statistik{$a}} keys %statistik;
  $i = 0;
  foreach (@keys)
  {
    print "$_ (<a href=\"http://www.ripe.net/perl/whois?searchtext=$_\" target=\"_blank\">Ripe.net</a>, ";
    $ip = $_; $ip =~ s/(\d*)\.(\d*)\.(\d*)\.(\d*)/ip1=$1&ip2=$2&ip3=$3&ip4=$4/;
    print "<a href=\"http://www.amnesi.com/hostinfo/ipinfo.jhtml?$ip\" target=\"_blank\">eAmnesia.com</a>)";

    print ": <b>$statistik{$_}</b> (";
    print int(100*$statistik{$_}/$anz); print "%)<br>";
    $i++;
    if ($i >= 50 || $statistik{$_} < 4) { last; }
  }

  undef @keys; undef %statistik;
  print "<h3>Hufigkeit bei den Namen</h3><p>";
  for ($i = 1; $i <= $anz; $i++) { $statistik{"\L$absender[$i]"}++; }
  @keys = sort {$statistik{$b} <=> $statistik{$a}} keys %statistik;
  $i = 0;
  foreach (@keys)
  {
    print "$_: <b>$statistik{$_}</b> (";
    print int(100*$statistik{$_}/$anz); print "%)<br>";
    $i++;
    if ($i >= 50 || $statistik{$_} < 4) { last; }
  }

  print "</p><p>[ <a href=\"$0\">Zur&uuml;ck</a> ]</p>";
  print $html_fuss; die;
}

#-----------------------------------------------------------------------------

sub datacheck
{
  # Das Zusatzmodul wird wirklich nur dann inkludiert, wenn es benoetigt wird
  if ($FORM{'olddate'} eq 'konvert') { require 'timelocal.pl'; }
  print $html_kopf;
  &alles_einlesen;
  for ($i = 1; $i <= $anz; $i++)
  {
    if ($betreff[$i] . $text[$i] eq $doppelvergleich)
    {
      if ($FORM{'doppel'} eq 'delete') { $id[$i] = 0; }
      else { $doppel++; $error = 1; }
    }
    else
    {
      $doppelvergleich = $betreff[$i] . $text[$i];
    }
    if ($re[$i] > 0 && &suche_arraynum($re[$i]) == -1)
    {
      if ($FORM{'zombies'} eq 'move') { $re[$i] = 0; }
      elsif ($FORM{'zombies'} eq 'delete') { $id[$i] = 0; }
      else { $zombies++; $error = 1; }
    }
    if ($datum[$i] =~ m/^[\d]{12}$/)
    {
      if ($FORM{'olddate'} eq 'konvert') { $datum[$i] =~ s/(....)(..)(..)(..)(..)/timelocal(0,$5,$4,$3,$2-1,$1-1900)/e; }
      else { $olddate++; $error = 1; }
    }
    if ($text[$i] =~ m/%e/ || $betreff[$i] =~ m/%e/ || $absender[$i] =~ m/%e/)
    {
      if ($FORM{'konvert_equal'} eq 'konvert') { $text[$i] =~ s/%e/=/g; $betreff[$i] =~ s/%e/=/g; $absender[$i] =~ s/%e/=/g; }
      else { $konvert_equal++; $error = 1; }
    }
    $absender[$i] =~ s/^anonym(ous)?$//i;
    $absender[$i] =~ s/^-$//i;
  }

  if ($FORM{'korrigieren'})
  {
    open(DATEI, ">$datafile") || die $!;
    flock(DATEI, 2);
    for ($i = 1; $i <= $anz; $i++)
    {
      if ($id[$i] < 1) { next; }
      print DATEI "id=$id[$i]&re=$re[$i]&betreff=$betreff[$i]&absender=$absender[$i]";
      if ($email[$i]) { print DATEI "&email=$email[$i]"; }
      print DATEI "&datum=$datum[$i]&text=$text[$i]&ip=$ip[$i]";
      #if ($sendmail[$i] > 0) { print DATEI '&sendmail=1'; }
      print DATEI "\n";
    }
    close(DATEI);
  }

  if ($error)
  {
    print qq!<p>Es wurden Fehler in der Konsistenz der Daten entdeckt.</p>
    <form action="$0" method=post><p><input type=hidden name="aktion" value="check">!;
    if ($doppel)
    {
      print qq!Doppelte Eintr&auml;ge
      <input type=checkbox name="doppel" value="delete" checked> l&ouml;schen ($doppel Fundstellen)<br>!;
    }
    if ($zombies)
    {
      print qq!Ungltige Zuordnungen
      <input type=radio name="zombies" value="move" checked> verschieben oder
      <input type=radio name="zombies" value="delete"> lschen ($zombies Fundstellen)<br>!;
    }
    if ($olddate)
    {
      print qq!Veraltetes Datumsformat
      <input type=checkbox name="olddate" value="konvert" checked> korrigieren ($olddate Fundstellen)<br>!;
    }
    if ($konvert_equal)
    {
      print qq!Falsch kodierte Gleichheitszeichen
      <input type=checkbox name="konvert_equal" value="konvert" checked> korrigieren ($konvert_equal Fundstellen)<br>!;
    }
    print qq!<input type=submit name="korrigieren" value="Korrigieren">
    </p></form>!;
  }
  else
  {
    print "Alle Eintr&auml;ge sind einwandfrei, es wurden keine Fehler gefunden.";
  }
  print "<p>[ <a href=\"$0\">Zur&uuml;ck</a> ]</p>";
  print $html_fuss; die;
}
